﻿using System;
using System.Collections.Generic;
using System.Text;
using DreamShield.Extentions;
using DreamShield.Deployment.Installers.DreamPlugins;
using DreamShield.Deployment.Assistants.DreamWizard.WizardInterfaces.StandardWizard;
using DreamShield.Deployment.Installers.DreamWorker;
using DreamShield.Deployment.Wizards.Workflow;
using DreamShield.Deployment.Wizards;
using DreamShield.Deployment.Wizards.Pages;

namespace DisableReInstallPlugin
{
    [Extention(BaseDreamPluginContainer.DreamPluginExtentionGuid,
  "{87282062-D105-43a6-9035-DCF358455163}")] //ID Unique
    public class UninstallReInstallModeDisablePlugin : BaseDreamPluginContainer
    {
        public UninstallReInstallModeDisablePlugin()
        {
            this.extentionAuthor = "Audrey";
            this.extentionCompany = "Copyright (C) Karim Audrey LUCCIN 2009";
            this.extentionDescription = "UninstallReInstallModeDisable pour DreamShield";
            this.extentionName = "UninstallReInstallModeDisable";
            this.extentionVersion = 0.1;
        }

        public override IDreamPluginServer GetPluginServer(DreamPluginsEngine engine)
        {
            return new UninstallReInstallModeDisablePluginServer(engine);
        }
    }

    /* classe qui va faire le relait entre le chargeur de DreamShield et le plugin */
    public class UninstallReInstallModeDisablePluginServer : BaseDreamPluginServer
    {
        public UninstallReInstallModeDisablePluginServer(DreamPluginsEngine engine)
            : base(engine)
        {            
            base.AddRegisteredModel(StandardWizardProvider.StandardWizardProvider_PluginsGuid,
                new UninstallReInstallModeDisable());
        }
    }

    public class UninstallReInstallModeDisable : BaseStandardWizardProvider_Plugin
    {
        public IBaseWizardForm Wizard { get; protected set; }

        public override void BuildWizard_End(WorkerActionId actionId)
        {
            base.BuildWizard_End(actionId);

            Wizard = Provider.InstallerForm;

            if (actionId == WorkerActionId.Uninstall)
            {
                WorkflowSequencer workflow = Wizard.GuiPagesSequencer;

                /* on cherche la page welcome */
                if (FindUninstallMode(workflow))
                {
                    /* les pages ont été ajoutés si nécéssaire */
                }
                else
                {
                    /* pas de page welcome trouvée :s */
                }
            }
        }

        private bool FindUninstallMode(WorkflowSequencer root)
        {
            WorkflowSequencer m_sequencer = null;
            foreach (IWorkflowSingleton singleton in root.Flows)
            {
                if (singleton.Id.Equals(StdWizardPageID.UninstallerModePage, StringComparison.OrdinalIgnoreCase))
                {
                    ProcessUninstallerModePage(root, singleton);
                    return true;
                }

                m_sequencer = singleton as WorkflowSequencer;

                if (m_sequencer != null)
                {
                    if (FindUninstallMode(m_sequencer))
                        return true;

                }
            }

            return false;
        }

        private void ProcessUninstallerModePage(WorkflowSequencer root, IWorkflowSingleton singleton)
        {
            var sn = singleton as WorkflowBasicPageSequence;
            if (sn != null && sn.Page != null)
            {
                var pg = sn.Page as UninstallerModePage;
                if (pg != null)
                {
                    pg.ModeReinstall.Enabled = false;
                }
            }
        }
    }
}
